
#include <stdio.h>
#include <stdlib.h>
#include "hexagon.h"

////////////////////////////////////////////////////////////////////
// push an integer on to the end of an array
void push(int *array, int value) {
  while(*array != 0) {
    ++array;
  }
  *array = value;
}


////////////////////////////////////////////////////////////////////

// construct a triangular mesh in the shape of a hexagon
// I worked this out on paper in an adhoc manner...  I wonder if 
// there is a nice library for this kind of thing?
extern t_hexagon *hexagon (int size) {
  int lengths[size];
  int x, y, i;
  int **hex;
  t_point *twod;
  int points = 0;
  int point = 0;
  int edges = 0;
  t_hexagon *result = (t_hexagon *) calloc(1, sizeof(t_hexagon));

  for (y = 0; y < size; ++y) {
    if (y <= (int) ((size - 1) / 2)) {
      lengths[y] = y + ((size - 1) / 2) + 1;
    }
    else {
      lengths[y] = size - y + ((size - 1) / 2);
    }
    points += lengths[y];
  }
  
  hex = (int **) calloc(points + 1, sizeof(int *));

  for (i = 0; i < points; i++) {
    hex[i] = (int *) calloc(1, sizeof(int) * 3);
  }

  twod = (t_point *) calloc(points, sizeof(t_point));
  
  for (y = 0; y < size; ++y) {
    int len = lengths[y];
    int offset = abs(((size-1)/2) - y);
    
    for (x = 0; x < len; ++x) {
      twod[point].y = y;
      twod[point].x = (x * 2) + offset;
      
      if (x < (len - 1)) {
	// 0 deg
	push(hex[point], point+1);
	edges++;
      }
      if (y < (size - 1)) {
	if (y < ((size - 1) / 2)) {
	  // 60 deg
	  push(hex[point], point + len + 1);
	  edges++;
	  // 120 deg
	  push(hex[point], point + len);
	  edges++;
	}
	else {
	  // 60 deg
	  if (x < (len - 1)) {
	    push(hex[point], point + len);
	    edges++;
	  }
	  // 120 deg
	  if (x > 0) {
	    push(hex[point], point + len - 1);
	    edges++;
	  }
	}
      }
      ++point;
    }
  }

#ifdef DEBUG
  for (i = 0; i < points; ++i) {
    printf("%d: ", i);
    for (x = 0; x < 3; ++x) {
      if (hex[i][x] == 0) {
	break;
      }
      printf(" %d ", hex[i][x]);
    }
    printf("\n");
  }
#endif

  result->hex = hex;
  result->edges = edges;
  result->junctions = points;
  result->size = size;
  result->twod = twod;

  return(result);
}
