
#ifdef __cplusplus
extern "C" {
#endif

// representation of a hexagon made up of triangles

/* hex - a 2d array of integers. The first dimension is the junction
 *   id, the second dimension is list of junction ids that junction
 *   connects to.  Only contains connections in one direction.  
 * twod - arranges the points in space, useful for visualising
 */

typedef struct {
  int x;
  int y;
} t_point;

typedef struct {
  int **hex;
  t_point *twod;
  int junctions; // number of junctions
  int edges;     // number of connections
  int size;      // height of hexagon
} t_hexagon;

extern t_hexagon *hexagon (int size);

#ifdef __cplusplus
}
#endif
